<?php
/**
 *  @autor    Martin Tomasek
 *  @license   https://creativecommons.org/licenses/by-sa/4.0/ CC BY-SA 4.0
 */

ini_set('max_execution_time', '0');

include_once(dirname(__FILE__).'/../../config/config.inc.php');
include_once('fcommon.php');
include_once('fcustomer.php');
include_once('fcategory.php');
include_once('fproduct.php');
include_once('forder.php');

$config = array(
    'DB_PREFIX' => _DB_PREFIX_,
    'LANG_ID' => (int)(Configuration::get('SAMBA_LANG')),
    'SHOP_ID' => (int)(Configuration::get('SAMBA_SHOP')),
    'EMPLOYEE_ID' => 1, #TODO: we are using this employee id to get correct prices. find a better solution.
    'SHOP_URL_BASE' => 'http://'.Configuration::get('PS_SHOP_DOMAIN_SSL').'/',
    'VARIANT_IDS' => true,
    'link' => new Link()
);

$common = new Common($config);

$feed_name = Tools::getValue('feed');
$key = Tools::getValue("key");
$SAMBA_KEY = Configuration::get('SAMBA_KEY');
if ($key != $SAMBA_KEY) {
    echo "<html><body>Wrong key, access denied.</body></html>";
    http_response_code(403);
    return;
}

if ($feed_name == "info") {
    header('Content-Type: text/plain');
    echo "Versions: \n";
    echo "prestashop: " . _PS_VERSION_ . "\n";
    echo "php: " . phpversion() . "\n";
    http_response_code(200);
    return;
}

$isCron = Configuration::get('SAMBA_CRON') == 1;
$feedFolder = 'feeds/';
$filePath = $feedFolder . $feed_name . '_working.xml';

if ($isCron && !is_dir($feedFolder)) {
    mkdir($feedFolder, 0777, true);
}

switch ($feed_name) {
    case 'customers':
        $cust = new FCustomer($common, Configuration::get('SAMBA_DATE'));
        if ($isCron) {
            $cust->genFeed($filePath);
            if (file_exists($filePath)) {
                rename($filePath, $feedFolder . $feed_name . '_done.xml');
            }
        } else {
            $cust->genFeed();
        }
        break;

    case 'categories':
        $cust = new FCategory($common);
        if ($isCron) {
            $cust->genFeed($filePath);
            if (file_exists($filePath)) {
                rename($filePath, $feedFolder . $feed_name . '_done.xml');
            }
        } else {
            $cust->genFeed();
        }
        break;

    case 'products':
        $cust = new FProduct($common);
        if ($isCron) {
            $cust->genFeed($filePath);
            if (file_exists($filePath)) {
                rename($filePath, $feedFolder . $feed_name . '_done.xml');
            }
        } else {
            $cust->genFeed();
        }
        break;

    case 'orders':
        $cust = new FOrder($common, Configuration::get('SAMBA_DATE'));
        if ($isCron) {
            $cust->genFeed($filePath);
            if (file_exists($filePath)) {
                rename($filePath, $feedFolder . $feed_name . '_done.xml');
            }
        } else {
            $cust->genFeed();
        }
        break;
}
